clean up and homogenize pgsql and mysql vserver checks
authorintrigeri <intrigeri@boum.org>
Thu, 19 Jan 2006 21:58:03 +0000 (21:58 +0000)
committerintrigeri <intrigeri@boum.org>
Thu, 19 Jan 2006 21:58:03 +0000 (21:58 +0000)
ChangeLog
handlers/mysql
handlers/pgsql

index d4e222697396d65b10c078f3f110bd90f466c884..47b3f916df6c91d04c1a7cb6472ba21fcc528857 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -5,8 +5,9 @@ version 0.9.3 -- unreleased
            programs such as PGSQLDUMP, so that users can figure
            out more easily they can customize them
         code refactor:
-        . now uses vservers lib to init vservers support
+        . now uses vservers lib to initialize vservers support
     handler changes
+        duplicity, mysql, pgsql, rdiff: use new lib/vserver functionality
         mysql:
          . fixed no user defaults file processing
        duplicity:
@@ -16,11 +17,7 @@ version 0.9.3 -- unreleased
           disabled in backupninja.conf
         . now works when multiple vservers names are given (separated by space)
           in vsnames config variable
-        . make use of new lib/vserver functionality
-        pgsql
-         . make use of new lib/vserver functionality
         rdiff
-        . make use of new lib/vserver functionality
         . fixed globbing bug in include, exclude and vsinclude options
     ninjahelper changes
         rdiff.helper:
index d3179309412bde11ca83bd85dd12165ac0c1bbed..3b82ddf99a048051e642884fc64b60129fc6a638 100644 (file)
@@ -19,33 +19,28 @@ getconf dbpassword
 getconf configfile /etc/mysql/debian.cnf
 
 
-# If vservers are configured, decide if the handler should
-# use them or if it should just operate on the host
-
-if [ "$vservers" = "yes" ]
-then
-       if [ ! -z $vsname ]
-       then            
-               info "Using vserver '$vsname'"
-               usevserver=1
-       else
-               info "No vserver name specified, actions will be performed on the host"
-       fi
-fi
-
-# If needed, make sure that the specified vserver exists and is running.
-if [ $usevserver ]
-then
-       debug "Examining vserver '$vsname'"
-       # does it exist ?
-       vroot="$VROOTDIR/$vsname"
-       [ -d $vroot ] || fatal "vserver '$vsname' does not exist at '$vroot'"
-       # is it running ?
-       $VSERVERINFO -q $vsname RUNNING
-       if [ $? -ne 0 ]
-       then
-               fatal "vserver $vsname is not running."
-       fi
+# Decide if the handler should operate on a vserver or on the host.
+# In the former case, check that $vsname exists and is running.
+local usevserver=no
+local vroot
+if [ $vservers_are_available = yes ]; then
+   if [ -z "$vsname" ]; then
+      # does it exist ?
+      if ! vservers_exist "$vsname" ; then
+         fatal "The vserver given in vsname ($vsname) does not exist."
+      fi
+      # is it running ?
+      $VSERVERINFO -q $vsname RUNNING
+      if [ $? -ne 0 ]; then
+         fatal "The vserver $vsname is not running."
+      fi
+      # everything ok
+      info "Using vserver '$vsname'."
+      usevserver=yes
+      vroot="$VROOTDIR/$vsname"
+   else
+      info "No vserver name specified, actions will be performed on the host."
+   fi
 fi
 
 ## Prepare ignore part of the command
@@ -63,7 +58,7 @@ done
 hotdir="$backupdir/hotcopy"
 dumpdir="$backupdir/sqldump"
 
-if [ $usevserver ]
+if [ $usevserver = yes ]
 then
        [ "$sqldump" == "no" -o -d $vroot$dumpdir ] || $VSERVER $vsname exec mkdir -p $dumpdir
        [ "$hotcopy" == "no" -o -d $vroot$hotdir ] || $VSERVER $vsname exec mkdir -p $hotdir
@@ -93,7 +88,7 @@ defaultsfile=""
 
 if [ "$dbusername" != "" -a "$dbpassword" != "" ]
 then
-    if [ $usevserver ]
+    if [ $usevserver = yes ]
     then
        vhome=`$VSERVER $vsname exec getent passwd "root" | awk -F: '{print $6}'`
        home="$vroot$vhome"
@@ -133,7 +128,7 @@ user=$dbusername
 password="$dbpassword"
 EOF
        umask $oldmask
-       if [ $usevserver ] 
+       if [ $usevserver = yes 
        then
            defaultsfile="--defaults-file=$vhome/.my.cnf"
        else
@@ -147,7 +142,7 @@ if [ "$user" == "" ]; then
        defaultsfile="--defaults-file=$configfile"
 else
        userset=true;
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
        then
            vuserhome=`$VSERVER $vsname exec getent passwd "$user" | awk -F: '{print $6}'`
            if [ $? -eq 2 ]
@@ -177,7 +172,7 @@ then
     info "Initializing hotcopy method"
     if [ "$databases" == "all" ]
     then
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
        then
                info "dbhost: $dbhost"
                execstr="$VSERVER $vsname exec $MYSQLHOTCOPY -h $dbhost --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
@@ -201,7 +196,7 @@ then
     else       
        for db in $databases
        do
-               if [ $usevserver ]
+               if [ $usevserver = yes ]
                then
                        execstr="$VSERVER $vsname exec $MYSQLHOTCOPY --allowold $db $hotdir"
                else
@@ -233,7 +228,7 @@ then
     info "Initializing SQL dump method"
     if [ "$databases" == "all" ]
     then
-       if [ $usevserver ]
+       if [ $usevserver = yes ]
        then
            debug "echo show databases | $VSERVER $vsname exec su $user -c $MYSQL $defaultsfile | grep -v Database"
            databases=`echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
@@ -252,7 +247,7 @@ fi
 
        for db in $databases
        do
-               if [ $usevserver ]
+               if [ $usevserver = yes ]
                then
                        execstr="$VSERVER $vsname exec $MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names $ignore $db > $vroot$dumpdir/${db}.sql"
                else
index 8629260720b60d0475bcadcb7b6727e8eecb4d66..2b6f25a421d67892c1c7218c68e66472ae7f3ddd 100644 (file)
@@ -10,45 +10,48 @@ getconf vsname
 
 localhost=`hostname`
 
-# If vservers are enabled, check that $vsname exists, and decide if the
-# handler should use it or if it should just operate on the host.
+# Decide if the handler should operate on a vserver or on the host.
+# In the former case, check that $vsname exists and is running.
 local usevserver=no
+local vroot
 if [ $vservers_are_available = yes ]; then
-   if ! vservers_exist "$vsname" ; then
-      fatal "The vserver given in vsname ($vsname) does not exist."
-   else
-      info "using vserver '$vsname'"
+   if [ -z "$vsname" ]; then
+      # does it exist ?
+      if ! vservers_exist "$vsname" ; then
+         fatal "The vserver given in vsname ($vsname) does not exist."
+      fi
+      # is it running ?
+      $VSERVERINFO -q $vsname RUNNING
+      if [ $? -ne 0 ]; then
+         fatal "The vserver $vsname is not running."
+      fi
+      # everything ok
+      info "Using vserver '$vsname'."
       usevserver=yes
+      vroot="$VROOTDIR/$vsname"
+   else
+      info "No vserver name specified, actions will be performed on the host."
    fi
 fi
 
-# As needed, make sure that :
-#   * the specified vserver is running
-#   * the specified vserver or host has the needed executables
+# Make sure that the system to backup has the needed executables
 if [ $usevserver = yes ]; then
-    info "examining vserver '$vsname'"
-    vroot="$VROOTDIR/$vsname"
-    # is it running ?
-    running=`$VSERVERINFO $vsname RUNNING`
-    if [ "$running" = "1" ]; then
-       if [ "$databases" == "all" ]; then
-           [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
-               fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
-       else
-           [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
-               fatal "Can't find $PGSQLDUMP in vserver $vsname."
-       fi
-    else
-       fatal "vserver $vsname is not running."
-    fi
+   debug "Examining vserver '$vsname'."
+   if [ "$databases" == "all" ]; then
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL in vserver $vsname."
+   else
+      [ -x "$vroot`$VSERVER $vsname exec which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP in vserver $vsname."
+   fi
 else
-    if [ "$databases" == "all" ]; then
-       [ -x "`which $PGSQLDUMPALL`" ] || \
-           fatal "Can't find $PGSQLDUMPALL."
-    else
-       [ -x "`which $PGSQLDUMP`" ] || \
-           fatal "Can't find $PGSQLDUMP."
-    fi
+   if [ "$databases" == "all" ]; then
+      [ -x "`which $PGSQLDUMPALL`" ] || \
+        fatal "Can't find $PGSQLDUMPALL."
+   else
+      [ -x "`which $PGSQLDUMP`" ] || \
+        fatal "Can't find $PGSQLDUMP."
+   fi
 fi
 
 # create backup dir, the vroot variable will be empty if no vsname was specified